#include "vname.h"
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include <sys/param.h>

/*
 * (c) Jan-Piet Mens <jpm@gin.pfm-mainz.de>
 * $Id: vname.c,v 1.1 1994/07/15 18:54:37 jpm Exp jpm $
 */

#ifndef MAXPATHLEN
# define MAXPATHLEN     (1024)
#endif
#define EOS             ('\0')
#define isvchar(c)      ((c) && ((isalnum((c))) || ((c) == '_')))

static char *homedir P_((char *uname));

char last_vname[MAXPATHLEN];

/*
 * Return a pointer to a newly-built path. The following patterns are
 * parsed in `path'.
 *
 *      ~/                              My home
 *      ~user/                          User's home
 *      .../$VAR/...                    Shell Environment
 */

char *vname(path)
char *path;
{
	static char rcs_id[] = "@(#)$Id: vname.c,v 1.1 1994/07/15 
18:54:37 jpm Exp jpm $";
	char *lp = last_vname;
	char buf[MAXPATHLEN + 1], *bp, *getlogin(), *getenv();

	if (*path == '~') {
		if ((*++path == '/') || (*path == EOS))         /* ~/ 
*/
			(void) strcpy(buf, getlogin());
		else {
			for (bp = buf; *path && (*path != '/'); )
				*bp++ = *path++;
			*bp = EOS;
		}
		(void) strcpy(last_vname, homedir(buf));
		lp += strlen(last_vname);
	}

	for (; path && *path;) {
		if (*path != '$')
			*lp++ = *path++;
		else {
			/*
			 * Find $SOMETHING
			 */

			*lp = EOS;
			for (bp = buf, ++path; isvchar(*path); path++)
				*bp++ = *path;
			*bp = EOS;

			/*
			 * Get variable from environment.
			 * If not found use the literal SOMETHING.
			 */

			bp = (bp = getenv(buf)) ? bp : buf;
			for (; bp && *bp; )
				*lp++ = *bp++;
		}
	}
	*lp = EOS;
	return (last_vname);
}

static char *homedir(user)
char *user;
{
	static struct passwd *pw;
	struct passwd *getpwnam();
	static char buf[64];

	if ((pw = getpwnam(user)) != (struct passwd *)0)
		return (pw->pw_dir);

	/*
	 * `user' not found. Return "~user" to indicate failure.
	 */

	*buf = '~';
	(void) strcpy(buf + 1, user);
	return (buf);
}

